var stateNormal   = 1;
var stateDown     = 2;
var stateDisabled = 3;
var stateHide     = 4;

var typeButton      = 0;
var typePlaceholder = 1;
var typeSlider      = 2;
var typeInfoDisplay = 3;
var typePicture     = 4;

var playStopped = 0;
var playPaused  = 1;
var playPlaying = 2;
var playWaiting = 3;

var ShuffleOff = 0;
var ShuffleOn  = 1;

var RepeatOff = 0;
var RepeatOn  = 1;

var MuteOff = 0;
var MuteOn  = 1;

var EQOff = 0;
var EQOn  = 1;

var defTransColor = "FF00FF";

var g_Playback = MJAutomation.GetPlayback();
var g_PlayingNow = MJAutomation.GetCurPlaylist();
var g_MCMixer = GetMJMixer();


//--------------------------------------------------------------------------


function OnExit()
{
  Metamorphis.SaveSkinState();
}


function OnInitialize()
{
  if (Metamorphis.LoadSkinState() == false)
  {
    Top.SetWindowPos(Main.Left, Main.Top);
    ControlsDn.SetWindowPos(Main.Left + 11, Main.Top + 10);
    ControlsUp.SetWindowPos(Main.Left + 11, Main.Top + 10);
    Middle.SetWindowPos(Main.Left, Main.Top + Top.Height);
    Address.SetWindowPos(Main.Left, Middle.Top + Middle.Height - 18);
    Bottom.SetWindowPos(Main.Left, Middle.Top + Middle.Height - 23);
    PixOS.SetWindowPos(Main.Left + 10, Bottom.Top + Bottom.Height - 23);
    Vid.SetWindowPos(Main.Left + 6, Top.Top + Top.Height - 6);
    VidFlag.SetWindowPos(Main.Left + 9, Main.Top);
    Playlist.SetWindowPos(Main.Left + 6, Top.Top + Top.Height - 6);
    Visualization.SetWindowPos(Main.Left + 230,Top.Top + 64);
    VisFlag.SetWindowPos(Main.Left + 10, Main.Top);
    EQ.SetWindowPos(Main.Left + 230,Top.Top + 64);

    Top.ShowWindow(true);
    ControlsDn.ShowWindow(true);
    ControlsUp.ShowWindow(false);
    Middle.ShowWindow(true);
    Address.ShowWindow(true);
    PixOS.ShowWindow(true);
    Vid.ShowWindow(true);
    VidFlag.ShowWindow(true);
    Playlist.ShowWindow(false);
    Visualization.ShowWindow(true);
    VisFlag.ShowWindow(true);
    EQ.ShowWindow(false);
    Bottom.ShowWindow(true);
  }

  Middle.SetWindowBehind(Playlist);
  Top.SetWindowBehind(Playlist);

  //Vid.GetSkinItem(typePlaceholder, "AV").SetPicture("audio.bmp");
  Vid.GetSkinItem(typeInfoDisplay, "ArtistLabel").Text= "Author";
  Vid.GetSkinItem(typeInfoDisplay, "AlbumLabel").Text= "Album";
  Vid.GetSkinItem(typeInfoDisplay, "TitleLabel").Text="Title";

  if (ControlsDn.IsWindowVisible == true)
    Top.GetSkinItem(typeButton,"TogglePlaylist").SetBitmap
      (Playlist.IsWindowVisible == true ? "pl-off.png" : "pl-on.png", defTransColor);
  else
    Top.GetSkinItem(typeButton, "TogglePlaylist").SetBitmap("pl-blank.png", defTransColor);

  if (ControlsDn.IsWindowVisible == true)
    Top.GetSkinItem(typeButton,"ToggleVis").SetBitmap
      (Visualization.IsWindowVisible == true ? "vis-off.png" : "vis-on.png", defTransColor);
  else
    Top.GetSkinItem(typeButton, "ToggleVis").SetBitmap("vis-blank.png", defTransColor);

  if (ControlsDn.IsWindowVisible == true)
    Top.GetSkinItem(typeButton,"ToggleEQ").SetBitmap
      (EQ.IsWindowVisible == true ? "eq-off.png" : "eq-on.png", defTransColor);
  else
    Top.GetSkinItem(typeButton, "ToggleEQ").SetBitmap("eq-blank.png", defTransColor);

  Bottom.GetSkinItem(typeButton,"Mode").SetBitmap
    (ControlsDn.IsWindowVisible == true ? "roll-up.bmp" : "roll-down.bmp", defTransColor);

  OnPlayStateChanged();
  SetShuffleButton();
  SetRepeatButton();
  OnMixerChanged();
}


function OnPlayStateChanged()
{
  var g_CurrentFile = g_PlayingNow.GetFile(g_PlayingNow.Position());
  var PathTest = "_" + g_CurrentFile.GetImageFile(3) + "_";

  if (g_PlayingNow.GetNumberFiles == 0)
  {
    ControlsDn.GetSkinItem(typeButton, "Previous").State=stateDisabled;
    ControlsDn.GetSkinItem(typeButton, "Play").State=stateDisabled;
    ControlsDn.GetSkinItem(typeButton, "Next").State=stateDisabled;
    ControlsDn.GetSkinItem(typeButton, "Stop").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Previous").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Play").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Next").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Stop").State=stateDisabled;
  }
  else
  {
    ControlsDn.GetSkinItem(typeButton, "Previous").State=stateNormal;
    ControlsDn.GetSkinItem(typeButton, "Play").State=stateNormal;
    ControlsDn.GetSkinItem(typeButton, "Next").State=stateNormal;
    ControlsDn.GetSkinItem(typeButton, "Stop").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Previous").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Play").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Next").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Stop").State=stateNormal;
  }

  ControlsDn.GetSkinItem(typeButton,"Play").SetBitmap
    (g_Playback.State == playPlaying ? "pause.png" : "play.png", defTransColor);

  ControlsUp.GetSkinItem(typeButton,"Play").SetBitmap
    (g_Playback.State == playPlaying ? "pause.png" : "play.png", defTransColor);

  if (g_Playback.State == playPlaying)
  {
    ControlsDn.GetSkinItem(typeButton,"Play").Tooltip="Pause";
    ControlsUp.GetSkinItem(typeButton,"Play").Tooltip="Pause";
  }
  else
  {
    ControlsDn.GetSkinItem(typeButton,"Play").Tooltip="Play";
    ControlsUp.GetSkinItem(typeButton,"Play").Tooltip="Play";
  }    

  if (g_Playback.State == playStopped)
  {
    Vid.GetSkinItem(typeInfoDisplay, "State").Text="Stopped";
    Vid.GetSkinItem(typeInfoDisplay, "Elapsed").Height=0;
    ControlsDn.GetSkinItem(typeButton, "Previous").State=stateDisabled;
    ControlsDn.GetSkinItem(typeButton, "Next").State=stateDisabled;
    ControlsDn.GetSkinItem(typeButton, "Stop").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Previous").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Next").State=stateDisabled;
    ControlsUp.GetSkinItem(typeButton, "Stop").State=stateDisabled;
  }
  else if (g_Playback.State == playPlaying)
  {

    //if (g_Playback.IsVideo() == true)
      //Vid.GetSkinItem(typePlaceholder, "AV").SetPicture("video.bmp");
    //else
      //Vid.GetSkinItem(typePlaceholder, "AV").SetPicture("audio.bmp");

    Vid.GetSkinItem(typeInfoDisplay, "State").Text="Playing";
    Vid.GetSkinItem(typeInfoDisplay, "Elapsed").Height=22;
    ControlsDn.GetSkinItem(typeButton, "Stop").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Stop").State=stateNormal;
  }
  else if (g_Playback.State == playPaused)
  {

    //if (g_Playback.IsVideo() == true)
      //Vid.GetSkinItem(typePlaceholder, "AV").SetPicture("video.bmp");
    //else
      //Vid.GetSkinItem(typePlaceholder, "AV").SetPicture("audio.bmp");


    Vid.GetSkinItem(typeInfoDisplay, "State").Text="Paused";
    Vid.GetSkinItem(typeInfoDisplay, "Elapsed").Height=22;
    ControlsDn.GetSkinItem(typeButton, "Stop").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Stop").State=stateNormal;
  }
  else if (g_Playback.State == playWaiting)
  {
    Vid.GetSkinItem(typeInfoDisplay, "State").Text="Waiting";
    Vid.GetSkinItem(typeInfoDisplay, "Elapsed").Height=0;
    ControlsDn.GetSkinItem(typeButton, "Stop").State=stateNormal;
    ControlsUp.GetSkinItem(typeButton, "Stop").State=stateNormal;
  }
}

function SetShuffleButton()
{
  Vid.GetSkinItem(typeButton, "Shuffle").SetBitmap
    (g_PlayingNow.Shuffle == ShuffleOff ? "shuf-on.bmp" : "shuf-off.bmp", defTransColor);

  Vid.GetSkinItem(typeButton, "Shuffle").ToolTip = 
    (g_PlayingNow.Shuffle == ShuffleOff ? "Turn Shuffle On" : "Turn Shuffle Off");
}

function ToggleShuffle()
{
  if (g_PlayingNow.Shuffle == ShuffleOff)
  {
    g_PlayingNow.Shuffle = ShuffleOn;
    g_PlayingNow.ReShuffleFiles();
  }
  else
    g_PlayingNow.Shuffle = ShuffleOff;

  SetShuffleButton();
}

function SetRepeatButton()
{
  Vid.GetSkinItem(typeButton, "Repeat").SetBitmap
    (g_PlayingNow.Continuous == RepeatOff ? "cont-on.bmp" : "cont-off.bmp", defTransColor);

  Vid.GetSkinItem(typeButton, "Repeat").ToolTip = 
    (g_PlayingNow.Continuous == RepeatOff ? "Turn Continuous Playback On" : "Turn Continuous Playback Off");
}

function ToggleRepeat()
{
  if (g_PlayingNow.Continuous == RepeatOff)
    g_PlayingNow.Continuous = RepeatOn;
  else
    g_PlayingNow.Continuous = RepeatOff;

  SetRepeatButton();
}

function OnMixerChanged()
{
  Vid.GetSkinItem(typeButton, "ToggleMute").SetBitmap
    (g_MCMixer.Mute == MuteOff ? "mute-on.bmp" : "mute-off.bmp", defTransColor);

  Vid.GetSkinItem(typeButton, "ToggleMute").ToolTip = 
    (g_MCMixer.Mute == MuteOff ? "Turn Mute On" : "Turn Mute Off");

  EQ.GetSkinItem(typeButton, "EQToggle").SetBitmap
    (g_MCMixer.EQOn == EQOff ? "eq-off.bmp" : "eq-on.bmp", defTransColor);

  EQ.GetSkinItem(typeButton, "EQToggle").ToolTip = 
    (g_MCMixer.EQOn == EQOff ? "Turn Equalizer On" : "Turn Equalizer Off");
}

function TogglePlaylist()
{
  if (Vid.IsWindowVisible() == true)
  {
    Vid.ShowWindow(false);
    VidFlag.ShowWindow(false);
    Playlist.ShowWindow(true);
    Top.GetSkinItem(typeButton, "TogglePlaylist").SetBitmap("pl-off.png", defTransColor);
  }
  else
  {
    Playlist.ShowWindow(false);
    Vid.ShowWindow(true);
    VidFlag.ShowWindow(true);
    Top.GetSkinItem(typeButton, "TogglePlaylist").SetBitmap("pl-on.png", defTransColor);
  }
}

function ToggleEQ()
{
  Visualization.ShowWindow(false);
  VisFlag.ShowWindow(false);
  Top.GetSkinItem(typeButton, "ToggleVis").SetBitmap("vis-on.png", defTransColor);
  EQ.ShowWindow(true);
  Top.GetSkinItem(typeButton, "ToggleEQ").SetBitmap("eq-off.png", defTransColor);
}

function ToggleVis()
{
  EQ.ShowWindow(false);
  Top.GetSkinItem(typeButton, "ToggleEQ").SetBitmap("eq-on.png", defTransColor);
  Visualization.ShowWindow(true);
  VisFlag.ShowWindow(true);
  Top.GetSkinItem(typeButton, "ToggleVis").SetBitmap("vis-off.png", defTransColor);
}

function Roll()
{
  if (ControlsDn.IsWindowVisible == true)
  {
    Vid.ShowWindow(false);
    Playlist.ShowWindow(false);
    EQ.ShowWindow(false);
    Visualization.ShowWindow(false);

    Address.ShowWindow(false);
    PixOS.ShowWindow(false);

    Middle.MoveWindowAnimated(0, -64, 4);
    Bottom.MoveWindowAnimated(0, -175, 4);

    Middle.ShowWindow(false);
    ControlsUp.ShowWindow(true);
    ControlsDn.ShowWindow(false);

    Top.GetSkinItem(typeButton, "TogglePlaylist").SetBitmap("pl-blank.png", defTransColor);
    Top.GetSkinItem(typeButton, "ToggleEQ").SetBitmap("eq-blank.png", defTransColor);
    Top.GetSkinItem(typeButton, "ToggleVis").SetBitmap("vis-blank.png", defTransColor);
    Bottom.GetSkinItem(typeButton, "Mode").SetBitmap("roll-down.bmp", defTransColor);
    Bottom.GetSkinItem(typeButton, "Mode").ToolTip="Roll Down";
  }
  else
  {
    Middle.ShowWindow(true);

    Bottom.MoveWindowAnimated(0, 175, 4);
    Middle.MoveWindowAnimated(0, 64, 4);

    ControlsDn.ShowWindow(true);
    ControlsUp.ShowWindow(false);

    Middle.SetWindowBehind(Playlist);
    Top.SetWindowBehind(Playlist);

    if (VidFlag.IsWindowVisible() == true)
    {
      Vid.ShowWindow(true);
      Top.GetSkinItem(typeButton, "TogglePlaylist").SetBitmap("pl-on.png", defTransColor);
    }
    else
    {
      Playlist.ShowWindow(true);
      Top.GetSkinItem(typeButton, "TogglePlaylist").SetBitmap("pl-off.png", defTransColor);
    }

    if (VisFlag.IsWindowVisible() == true)
    {
      Visualization.ShowWindow(true);
      Top.GetSkinItem(typeButton, "ToggleEQ").SetBitmap("eq-on.png", defTransColor);
      Top.GetSkinItem(typeButton, "ToggleVis").SetBitmap("vis-off.png", defTransColor);
    }
    else
    {
      EQ.ShowWindow(true);
      Top.GetSkinItem(typeButton, "ToggleEQ").SetBitmap("eq-off.png", defTransColor);
      Top.GetSkinItem(typeButton, "ToggleVis").SetBitmap("vis-on.png", defTransColor);
    }

    Address.ShowWindow(true);
    PixOS.ShowWindow(true);
    
    Bottom.GetSkinItem(typeButton, "Mode").SetBitmap("roll-up.bmp", defTransColor);
    Bottom.GetSkinItem(typeButton, "Mode").ToolTip="Roll Up";
  }
}